#ifdef WIN32
#include <windows.h>
#endif

#include <GL/gl.h>
#include "ObjectBase.h"


ObjectBase::~ObjectBase()
{
}

void ObjectBase::render() const
{
	glPushMatrix();

	const dReal *p = dBodyGetPosition(body);
	const dReal *r = dBodyGetRotation(body);
	GLfloat m[16];

	m[ 0] = (GLfloat)r[ 0]; m[ 1] = (GLfloat)r[ 4]; m[ 2] = (GLfloat)r[ 8]; m[ 3] = (GLfloat)0;
	m[ 4] = (GLfloat)r[ 1]; m[ 5] = (GLfloat)r[ 5]; m[ 6] = (GLfloat)r[ 9]; m[ 7] = (GLfloat)0;
	m[ 8] = (GLfloat)r[ 2]; m[ 9] = (GLfloat)r[ 6]; m[10] = (GLfloat)r[10]; m[11] = (GLfloat)0;
	m[12] = (GLfloat)p[ 0]; m[13] = (GLfloat)p[ 1]; m[14] = (GLfloat)p[ 2]; m[15] = (GLfloat)1;
	glMultMatrixf( m );
	
	renderInLocalFrame();

	glPopMatrix();
}

void ObjectBase::setPosition(dReal x, dReal y, dReal z)
{
	dBodySetPosition(body, x, y, z);
}